/**
 * 
 */
package org.gcube.accounting.datamodel.backwardcompatibility;

import java.io.Serializable;

import org.gcube.accounting.datamodel.UsageRecord;
import org.gcube.accounting.datamodel.basetypes.AbstractTaskUsageRecord;
import org.gcube.accounting.datamodel.decorators.FieldAction;
import org.gcube.accounting.exception.InvalidValueException;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 *
 */
public class MoveToTaskStartTimeAction implements FieldAction {

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Comparable<? extends Serializable> validate(String key,
			Comparable<? extends Serializable> value, UsageRecord usageRecord)
			throws InvalidValueException {
		usageRecord.setResourceProperty(AbstractTaskUsageRecord.TASK_START_TIME, value);
		return usageRecord.getResourceProperty(AbstractTaskUsageRecord.TASK_START_TIME);
	}

}
